# wxAuiManager Class Reference
[Window Docking (wxAUI)]

`#include <wx/aui/framemanager.h>`

Inheritance diagram for wxAuiManager:
[legend]

## Detailed Description

wxAuiManager is the central class of the wxAUI class framework.

wxAuiManager manages the panes associated with it for a particular wxFrame, using a pane's wxAuiPaneInfo information to determine each pane's docking and floating behaviour.

wxAuiManager uses wxWidgets' sizer mechanism to plan the layout of each frame. It uses a replaceable dock art class to do all drawing, so all drawing is localized in one area, and may be customized depending on an application's specific needs.

wxAuiManager works as follows: the programmer adds panes to the class, or makes changes to existing pane properties (dock position, floating state, show state, etc.). To apply these changes, wxAuiManager's Update() function is called. This batch processing can be used to avoid flicker, by modifying more than one pane at a time, and then "committing" all of the changes at once by calling Update().

Panes can be added quite easily:

        wxTextCtrl* text1 = new wxTextCtrl(this, -1);
        wxTextCtrl* text2 = new wxTextCtrl(this, -1);
        m_mgr.AddPane(text1, wxLEFT, "Pane Caption");
        m_mgr.AddPane(text2, wxBOTTOM, "Pane Caption");
        m_mgr.Update();

Later on, the positions can be modified easily. The following will float an existing pane in a tool window:

        m_mgr.GetPane(text1).Float();

## Layers, Rows and Directions, Positions

Inside wxAUI, the docking layout is figured out by checking several pane parameters. Four of these are important for determining where a pane will end up:

- Direction: Each docked pane has a direction, Top, Bottom, Left, Right, or Center. This is fairly self-explanatory. The pane will be placed in the location specified by this variable.
- Position: More than one pane can be placed inside of a dock. Imagine two panes being docked on the left side of a window. One pane can be placed over another. In proportionally managed docks, the pane position indicates its sequential position, starting with zero. So, in our scenario with two panes docked on the left side, the top pane in the dock would have position 0, and the second one would occupy position 1.
- Row: A row can allow for two docks to be placed next to each other. One of the most common places for this to happen is in the toolbar. Multiple toolbar rows are allowed, the first row being row 0, and the second row 1. Rows can also be used on vertically docked panes.
- Layer: A layer is akin to an onion. Layer 0 is the very center of the managed pane. Thus, if a pane is in layer 0, it will be closest to the center window (also sometimes known as the "content window"). Increasing layers "swallow up" all layers of a lower value. This can look very similar to multiple rows, but is different because all panes in a lower level yield to panes in higher levels. The best way to understand layers is by running the wxAUI sample.

## Events emitted by this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxAuiManagerEvent& event)
Event macros for events emitted by this class:

- EVT_AUI_PANE_BUTTON(func):
  Triggered when any button is pressed for any docked panes.
- EVT_AUI_PANE_CLOSE(func):
  Triggered when a docked or floating pane is closed.
- EVT_AUI_PANE_MAXIMIZE(func):
  Triggered when a pane is maximized.
- EVT_AUI_PANE_RESTORE(func):
  Triggered when a pane is restored.
- EVT_AUI_RENDER(func):
  This event can be caught to override the default renderer in order to custom draw your wxAuiManager window (not recommended).

##

Library: wxBase

Category: Window Docking (wxAUI)

See also:
  wxAUI Overview, wxAuiNotebook, wxAuiDockArt, wxAuiPaneInfo

## Public Member Functions
| wxAuiManager (wxWindow *managed_wnd=NULL, unsigned int flags=wxAUI_MGR_DEFAULT)
| Constructor.
virtual | ~wxAuiManager ()
| Dtor.
bool | DetachPane (wxWindow *window)
| Tells the wxAuiManager to stop managing the pane specified by window.
wxAuiPaneInfoArray & | GetAllPanes ()
| Returns an array of all panes managed by the frame manager.
wxAuiDockArt * | GetArtProvider () const
| Returns the current art provider being used.
void | GetDockSizeConstraint (double *widthpct, double *heightpct) const
| Returns the current dock constraint values.
unsigned int | GetFlags () const
| Returns the current manager's flags.
wxWindow * | GetManagedWindow () const
| Returns the frame currently being managed by wxAuiManager.
virtual void | HideHint ()
| HideHint() hides any docking hint that may be visible.
bool | InsertPane (wxWindow *window, const wxAuiPaneInfo &insert_location, int insert_level=wxAUI_INSERT_PANE)
| This method is used to insert either a previously unmanaged pane window into the frame manager, or to insert a currently managed pane somewhere else.
void | LoadPaneInfo (wxString pane_part, wxAuiPaneInfo &pane)
| LoadPaneInfo() is similar to LoadPerspective, with the exception that it only loads information about a single pane.
bool | LoadPerspective (const wxString &perspective, bool update=true)
| Loads a saved perspective.
wxString | SavePaneInfo (wxAuiPaneInfo &pane)
| SavePaneInfo() is similar to SavePerspective, with the exception that it only saves information about a single pane.
wxString | SavePerspective ()
| Saves the entire user interface layout into an encoded wxString, which can then be stored by the application (probably using wxConfig).
void | SetArtProvider (wxAuiDockArt *art_provider)
| Instructs wxAuiManager to use art provider specified by parameter art_provider for all drawing calls.
void | SetDockSizeConstraint (double widthpct, double heightpct)
| When a user creates a new dock by dragging a window into a docked position, often times the large size of the window will create a dock that is unwieldly large.
void | SetFlags (unsigned int flags)
| This method is used to specify wxAuiManager's settings flags.
void | SetManagedWindow (wxWindow *managed_wnd)
| Called to specify the frame or window which is to be managed by wxAuiManager.
virtual void | ShowHint (const wxRect &rect)
| This function is used by controls to explicitly show a hint window at the specified rectangle.
void | UnInit ()
| Uninitializes the framework and should be called before a managed frame or window is destroyed.
void | Update ()
| This method is called after any number of changes are made to any of the managed panes.
bool | AddPane (wxWindow *window, const wxAuiPaneInfo &pane_info)
| AddPane() tells the frame manager to start managing a child window.
bool | AddPane (wxWindow *window, int direction=wxLEFT, const wxString &caption=wxEmptyString)
| AddPane() tells the frame manager to start managing a child window.
bool | AddPane (wxWindow *window, const wxAuiPaneInfo &pane_info, const wxPoint &drop_pos)
| AddPane() tells the frame manager to start managing a child window.
wxAuiPaneInfo & | GetPane (wxWindow *window)
| GetPane() is used to lookup a wxAuiPaneInfo object either by window pointer or by pane name, which acts as a unique id for a window pane.
wxAuiPaneInfo & | GetPane (const wxString &name)
| GetPane() is used to lookup a wxAuiPaneInfo object either by window pointer or by pane name, which acts as a unique id for a window pane.
## Static Public Member Functions
static wxAuiManager * | GetManager (wxWindow *window)
| Calling this method will return the wxAuiManager for a given window.
## Protected Member Functions
virtual bool | ProcessDockResult (wxAuiPaneInfo &target, const wxAuiPaneInfo &new_pos)
| ProcessDockResult() is a protected member of the wxAUI layout manager.

List of all members.

## Constructor & Destructor Documentation

wxAuiManager::wxAuiManager | ( | wxWindow * | managed_wnd = `NULL`,
|  | unsigned int | flags = `wxAUI_MGR_DEFAULT` |
| ) |  |  |

Constructor.

managed_wnd specifies the wxFrame which should be managed. flags specifies options which allow the frame management behaviour to be modified.

virtual wxAuiManager::~wxAuiManager | ( |  | ) | `[virtual]`

Dtor.

## Member Function Documentation

bool wxAuiManager::AddPane | ( | wxWindow * | window,
|  | const wxAuiPaneInfo & | pane_info,
|  | const wxPoint & | drop_pos |
| ) |  |  |

AddPane() tells the frame manager to start managing a child window.

There are several versions of this function. The first version allows the full spectrum of pane parameter possibilities. The second version is used for simpler user interfaces which do not require as much configuration. The last version allows a drop position to be specified, which will determine where the pane will be added.

bool wxAuiManager::AddPane | ( | wxWindow * | window,
|  | int | direction = `wxLEFT`,
|  | const wxString & | caption = `wxEmptyString` |
| ) |  |  |

AddPane() tells the frame manager to start managing a child window.

There are several versions of this function. The first version allows the full spectrum of pane parameter possibilities. The second version is used for simpler user interfaces which do not require as much configuration. The last version allows a drop position to be specified, which will determine where the pane will be added.

bool wxAuiManager::AddPane | ( | wxWindow * | window,
|  | const wxAuiPaneInfo & | pane_info |
| ) |  |  |

AddPane() tells the frame manager to start managing a child window.

There are several versions of this function. The first version allows the full spectrum of pane parameter possibilities. The second version is used for simpler user interfaces which do not require as much configuration. The last version allows a drop position to be specified, which will determine where the pane will be added.

bool wxAuiManager::DetachPane | ( | wxWindow * | window | ) |

Tells the wxAuiManager to stop managing the pane specified by window.

The window, if in a floated frame, is reparented to the frame managed by wxAuiManager.

wxAuiPaneInfoArray& wxAuiManager::GetAllPanes | ( |  | ) |

Returns an array of all panes managed by the frame manager.

wxAuiDockArt* wxAuiManager::GetArtProvider | ( |  | ) | const

Returns the current art provider being used.

See also:
  wxAuiDockArt.

void wxAuiManager::GetDockSizeConstraint | ( | double * | widthpct,
|  | double * | heightpct |
| ) |  |  | const

Returns the current dock constraint values.

See SetDockSizeConstraint() for more information.

unsigned int wxAuiManager::GetFlags | ( |  | ) | const

Returns the current manager's flags.

wxWindow* wxAuiManager::GetManagedWindow | ( |  | ) | const

Returns the frame currently being managed by wxAuiManager.

static wxAuiManager* wxAuiManager::GetManager | ( | wxWindow * | window | ) | `[static]`

Calling this method will return the wxAuiManager for a given window.

The window parameter should specify any child window or sub-child window of the frame or window managed by wxAuiManager.

The window parameter need not be managed by the manager itself, nor does it even need to be a child or sub-child of a managed window. It must however be inside the window hierarchy underneath the managed window.

wxAuiPaneInfo& wxAuiManager::GetPane | ( | const wxString & | name | ) |

GetPane() is used to lookup a wxAuiPaneInfo object either by window pointer or by pane name, which acts as a unique id for a window pane.

The returned wxAuiPaneInfo object may then be modified to change a pane's look, state or position. After one or more modifications to wxAuiPaneInfo, wxAuiManager::Update() should be called to commit the changes to the user interface. If the lookup failed (meaning the pane could not be found in the manager), a call to the returned wxAuiPaneInfo's IsOk() method will return false.

wxAuiPaneInfo& wxAuiManager::GetPane | ( | wxWindow * | window | ) |

GetPane() is used to lookup a wxAuiPaneInfo object either by window pointer or by pane name, which acts as a unique id for a window pane.

The returned wxAuiPaneInfo object may then be modified to change a pane's look, state or position. After one or more modifications to wxAuiPaneInfo, wxAuiManager::Update() should be called to commit the changes to the user interface. If the lookup failed (meaning the pane could not be found in the manager), a call to the returned wxAuiPaneInfo's IsOk() method will return false.

virtual void wxAuiManager::HideHint | ( |  | ) | `[virtual]`

HideHint() hides any docking hint that may be visible.

bool wxAuiManager::InsertPane | ( | wxWindow * | window,
|  | const wxAuiPaneInfo & | insert_location,
|  | int | insert_level = `wxAUI_INSERT_PANE` |
| ) |  |  |

This method is used to insert either a previously unmanaged pane window into the frame manager, or to insert a currently managed pane somewhere else.

InsertPane() will push all panes, rows, or docks aside and insert the window into the position specified by insert_location.

Because insert_location can specify either a pane, dock row, or dock layer, the insert_level parameter is used to disambiguate this. The parameter insert_level can take a value of wxAUI_INSERT_PANE, wxAUI_INSERT_ROW or wxAUI_INSERT_DOCK.

void wxAuiManager::LoadPaneInfo | ( | wxString | pane_part,
|  | wxAuiPaneInfo & | pane |
| ) |  |  |

LoadPaneInfo() is similar to LoadPerspective, with the exception that it only loads information about a single pane.

It is used in combination with SavePaneInfo().

bool wxAuiManager::LoadPerspective | ( | const wxString & | perspective,
|  | bool | update = `true` |
| ) |  |  |

Loads a saved perspective.

If update is true, wxAuiManager::Update() is automatically invoked, thus realizing the saved perspective on screen.

virtual bool wxAuiManager::ProcessDockResult | ( | wxAuiPaneInfo & | target,
|  | const wxAuiPaneInfo & | new_pos |
| ) |  |  | `[protected, virtual]`

ProcessDockResult() is a protected member of the wxAUI layout manager.

It can be overridden by derived classes to provide custom docking calculations.

wxString wxAuiManager::SavePaneInfo | ( | wxAuiPaneInfo & | pane | ) |

SavePaneInfo() is similar to SavePerspective, with the exception that it only saves information about a single pane.

It is used in combination with LoadPaneInfo().

wxString wxAuiManager::SavePerspective | ( |  | ) |

Saves the entire user interface layout into an encoded wxString, which can then be stored by the application (probably using wxConfig).

When a perspective is restored using LoadPerspective(), the entire user interface will return to the state it was when the perspective was saved.

void wxAuiManager::SetArtProvider | ( | wxAuiDockArt * | art_provider | ) |

Instructs wxAuiManager to use art provider specified by parameter art_provider for all drawing calls.

This allows plugable look-and-feel features. The previous art provider object, if any, will be deleted by wxAuiManager.

See also:
  wxAuiDockArt.

void wxAuiManager::SetDockSizeConstraint | ( | double | widthpct,
|  | double | heightpct |
| ) |  |  |

When a user creates a new dock by dragging a window into a docked position, often times the large size of the window will create a dock that is unwieldly large.

wxAuiManager by default limits the size of any new dock to 1/3 of the window size. For horizontal docks, this would be 1/3 of the window height. For vertical docks, 1/3 of the width.

Calling this function will adjust this constraint value. The numbers must be between 0.0 and 1.0. For instance, calling SetDockSizeContraint with 0.5, 0.5 will cause new docks to be limited to half of the size of the entire managed window.

void wxAuiManager::SetFlags | ( | unsigned int | flags | ) |

This method is used to specify wxAuiManager's settings flags.

flags specifies options which allow the frame management behaviour to be modified.

void wxAuiManager::SetManagedWindow | ( | wxWindow * | managed_wnd | ) |

Called to specify the frame or window which is to be managed by wxAuiManager.

Frame management is not restricted to just frames. Child windows or custom controls are also allowed.

virtual void wxAuiManager::ShowHint | ( | const wxRect & | rect | ) | `[virtual]`

This function is used by controls to explicitly show a hint window at the specified rectangle.

It is rarely called, and is mostly used by controls implementing custom pane drag/drop behaviour. The specified rectangle should be in screen coordinates.

void wxAuiManager::UnInit | ( |  | ) |

Uninitializes the framework and should be called before a managed frame or window is destroyed.

UnInit() is usually called in the managed wxFrame's destructor. It is necessary to call this function before the managed frame or window is destroyed, otherwise the manager cannot remove its custom event handlers from a window.

void wxAuiManager::Update | ( |  | ) |

This method is called after any number of changes are made to any of the managed panes.

Update() must be invoked after AddPane() or InsertPane() are called in order to "realize" or "commit" the changes. In addition, any number of changes may be made to wxAuiPaneInfo structures (retrieved with wxAuiManager::GetPane), but to realize the changes, Update() must be called. This construction allows pane flicker to be avoided by updating the whole layout at one time.

|  | [ top ]